# Bootstrap simulation to calculate cosine similarity within a cluster
library(proxy)
library(dplyr)
library(igraph)

# Get the name of a file in a directory whose name ends in .csv
# The .csv file is the data on the number of each obsidian provenance for each site in the cluster, one site per row.
csv_list <- list.files(pattern = "*.csv")
csv_list

#length(csv_list)
all_vec <- vector()

for(n in 1:100){
  simil_vec <- vector()
  for(f in 1:length(csv_list)){
    csvfilename = csv_list[f]
    dat.df <- read.csv(csvfilename, header=T, row.names=1)
  
    cls_num <- nrow(dat.df)
    sanchi_num <-ncol(dat.df)
    all_num <- cls_num*(sanchi_num - 1) # Last column is total
    clsnames_vec <- rownames(dat.df)
    sanchinames_vec <- colnames(dat.df)
    #simil_vec <- vector()
  
    # Create an empty data frame
    kara_df <- data.frame(matrix(rep(NA,all_num),nrow=cls_num))
    kara_df[is.na(kara_df)] <- 0
    for(i in 1:cls_num){
      kokuyo_vec <- vector()
      for(j in 1:(sanchi_num-1)){
        kokuyo_num <- dat.df[i,j]
        if(kokuyo_num > 0){
          for(k in 1:kokuyo_num){
            sanchinames_vec[j]
            kokuyo_vec <- append(kokuyo_vec, sanchinames_vec[j])
          }
        }
      }
      sampling_vec <- sample(kokuyo_vec, length(kokuyo_vec), replace=TRUE)
      for(m in 1:length(sampling_vec)){
        sample_sanchi <- sampling_vec[m]
        switch(sample_sanchi, 
               "TK" = kara_df[i,1] <- kara_df[i,1]+1,
               "WD" = kara_df[i,2] <- kara_df[i,2]+1,
               "OM" = kara_df[i,3] <- kara_df[i,3]+1,
               "SW" = kara_df[i,4] <- kara_df[i,4]+1,
               "TT" = kara_df[i,5] <- kara_df[i,5]+1,
               "KD" = kara_df[i,6] <- kara_df[i,6]+1,
               "HN" = kara_df[i,7] <- kara_df[i,7]+1,
               "AM" = kara_df[i,8] <- kara_df[i,8]+1,
        )
      }
    }
    sampling_df <- data.frame(kara_df/rowSums(kara_df))


    # Create a cosine similarity matrix  
    dat.mat <- simil(sampling_df, method="cosine") %>%
      as.matrix()
    
    # Lower triangular matrix only
    dat.mat2 <- dat.mat[upper.tri(dat.mat, diag = TRUE)]
    
    simil <- mean(dat.mat2, na.rm = TRUE)
    simil_vec <- append(simil_vec, simil)
    
  }
  print(n)
  print(simil_vec)
  all_vec <- append(all_vec, mean(simil_vec))
}

mean(all_vec)
sd(all_vec)
